%
%   Fading channel
%   The normalized fading rate = f_dm/1/T = N_fdm/NN
%

fdmT=1/2^7;

Nfdm=2^8;

NN=Nfdm/fdmT
small_val=0.001;
f=0:Nfdm;f=f-small_val;
% generate 32 values of Doppler spectrum
Sf=(pi*(1-(f/Nfdm).^2)).^(-1/4);
% The filter is
Filter=[Sf zeros(1,NN-2*Nfdm-1) fliplr(Sf(1,2:Nfdm+1))];
time_filter=ifft(Filter);time_filter=time_filter/norm(time_filter);
Filter2=fft(time_filter);
Filter=Filter*(Nfdm*2/norm(Filter));

% Generate the independant time-domain gaussian process
gt=sqrt(.5)*(randn(1, NN)+j*randn(1,NN));
Gt=fft(gt);
Rf=Filter.*Gt;
Rf2=Filter2.*Gt;
rayleigh=ifft(Rf);norm(rayleigh).^2/length(rayleigh)
rayleigh2=ifft(Rf2);norm(rayleigh2).^2/length(rayleigh)
clf

plot(real(rayleigh),'-y');hold on;
plot(imag(rayleigh),'-r');hold off;

